import React, {Fragment} from 'react';

const MetaPlate = ({ data, children }) => {
    //console.log(children, data)
    const buildProps = (data, {props:{prop, keyDataKey, sourceDataKey}}) =>  {
        let result = {}
        result[prop || 'children'] = data
        result.key = data && data[keyDataKey] || sourceDataKey

        return result
    }

    const build = (data, meta) => {
        if (!meta) return <></>;

        if (data instanceof Array){ //Array of data - container component
            if (meta instanceof Array) meta = meta[0];
            const Render = meta.type
            const {key, ...props} = buildProps(data, meta)
            return  (<Render key={key} {...props}>
                     {data.map(d => build(d, meta.props.children))}
                     </Render>
                    )
        }
        else if (data instanceof Object){ //object
            if (!(meta instanceof Array)) meta = [meta]

                return meta.map(m => {
                    const Render = m.type
                    const {sourceDataKey}  = m.props
                    const d = sourceDataKey ? data[sourceDataKey] : data
                    const {key, ...props} = buildProps(d, m)

                    if (!d) return <Fragment key={key} />
                    if (d instanceof Array) return build(d, m)
                        return <Render children={build(d, m.props.children)} key={key} {...props}/>
                })
        }
    }
    return <React.Fragment>{build(data, children)}</React.Fragment>
}

export default MetaPlate;
